Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/Makefile.common	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -40,7 +40,9 @@
 	$(USPACEDIR)/srv/bd/rd/rd \
 	$(USPACEDIR)/srv/vfs/vfs
+
 ifeq ($(RDFMT),tmpfs)
 	INIT_TASKS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
 endif
+
 ifeq ($(RDFMT),fat)
 	INIT_TASKS += $(USPACEDIR)/srv/fs/fat/fat
@@ -60,9 +62,18 @@
 	$(USPACEDIR)/srv/taskmon/taskmon \
 	$(USPACEDIR)/srv/hw/netif/dp8390/dp8390 \
+	$(USPACEDIR)/srv/net/netif/lo/lo \
+	$(USPACEDIR)/srv/net/il/arp/arp \
+	$(USPACEDIR)/srv/net/il/ip/ip \
+	$(USPACEDIR)/srv/net/tl/icmp/icmp \
+	$(USPACEDIR)/srv/net/tl/udp/udp \
+	$(USPACEDIR)/srv/net/tl/tcp/tcp \
 	$(USPACEDIR)/srv/net/net/net \
 	$(USPACEDIR)/srv/net/netstart/netstart \
-	$(USPACEDIR)/srv/net/netif/lo/lo \
-	$(USPACEDIR)/srv/net/nil/eth/eth \
-	$(USPACEDIR)/srv/net/nil/nildummy/nildummy
+
+ifneq ($(CONFIG_NETIF_NIL_BUNDLE),y)
+	RD_SRVS += \
+		$(USPACEDIR)/srv/net/nil/eth/eth \
+		$(USPACEDIR)/srv/net/nil/nildummy/nildummy
+endif
 
 RD_APPS = \
@@ -78,8 +89,12 @@
 	$(USPACEDIR)/app/tetris/tetris \
 	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/nettest1/nettest1 \
+	$(USPACEDIR)/app/nettest2/nettest2 \
 	$(USPACEDIR)/app/netecho/netecho \
 	$(USPACEDIR)/app/ping/ping \
-	$(USPACEDIR)/app/nettest1/nettest1 \
-	$(USPACEDIR)/app/nettest2/nettest2
+	$(USPACEDIR)/app/stats/stats \
+	$(USPACEDIR)/app/tasks/tasks \
+	$(USPACEDIR)/app/top/top
+#	$(USPACEDIR)/app/dummy_load/dummy_load
 
 COMPONENTS = \
@@ -91,7 +106,9 @@
 	$(USPACEDIR)/srv/bd/rd/rd \
 	$(USPACEDIR)/srv/vfs/vfs
+
 ifeq ($(RDFMT),tmpfs)
 	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
 endif
+
 ifeq ($(RDFMT),fat)
 	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
@@ -99,14 +116,5 @@
 
 NET_CFG = \
-	$(USPACEDIR)/srv/net/cfg/$(CONFIG_NETWORKING)/general \
-	$(USPACEDIR)/srv/net/cfg/$(CONFIG_NETWORKING)/lo \
-	$(USPACEDIR)/srv/net/cfg/$(CONFIG_NETWORKING)/ne2k
-
-ifeq ($(CONFIG_NETWORKING),modular)
-	RD_SRVS += \
-		$(USPACEDIR)/srv/net/il/ip/ip \
-		$(USPACEDIR)/srv/net/il/arp/arp \
-		$(USPACEDIR)/srv/net/tl/udp/udp \
-		$(USPACEDIR)/srv/net/tl/tcp/tcp \
-		$(USPACEDIR)/srv/net/tl/icmp/icmp
-endif
+	$(USPACEDIR)/srv/net/cfg/general \
+	$(USPACEDIR)/srv/net/cfg/lo \
+	$(USPACEDIR)/srv/net/cfg/ne2k
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/amd64/Makefile.inc	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -39,5 +39,5 @@
 build: $(BASE)/image.iso
 
-$(BASE)/image.iso: arch/$(BARCH)/grub/stage2_eltorito $(KERNELDIR)/kernel.bin $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
+$(BASE)/image.iso: arch/$(BARCH)/grub/stage2_eltorito $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	mkdir -p $(TMP)/boot/grub
 	cp arch/$(BARCH)/grub/stage2_eltorito $(TMP)/boot/grub/
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/arm32/Makefile.inc	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -27,7 +27,9 @@
 #
 
+include Makefile.common
+
 build: $(BASE)/image.boot
 
-$(BASE)/image.boot:
+$(BASE)/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 	cp arch/$(BARCH)/loader/image.boot $@
Index: boot/arch/arm32/loader/main.c
===================================================================
--- boot/arch/arm32/loader/main.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/arm32/loader/main.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -48,5 +48,5 @@
 
 /** Kernel entry point address. */
-#define KERNEL_VIRTUAL_ADDRESS 0x80200000
+#define KERNEL_VIRTUAL_ADDRESS 0x80800000
 
 
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/ia64/Makefile.inc	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -27,7 +27,9 @@
 #
 
+include Makefile.common
+
 build: $(BASE)/image.boot
 
-$(BASE)/image.boot:
+$(BASE)/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 	cp arch/$(BARCH)/loader/image.boot $@
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/mips32/Makefile.inc	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -27,7 +27,9 @@
 #
 
+include Makefile.common
+
 build: $(BASE)/image.boot
 
-$(BASE)/image.boot:
+$(BASE)/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 	cp arch/$(BARCH)/loader/image.boot $@
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/ppc32/Makefile.inc	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -41,5 +41,5 @@
 	mkisofs -hfs -part -map arch/$(BARCH)/yaboot/maps -no-desktop -hfs-volid "HelenOS" -hfs-bless $(TMP)/boot -r -o $@ $(TMP)/
 
-arch/$(BARCH)/loader/image.boot:
+arch/$(BARCH)/loader/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 
Index: boot/arch/ppc32/loader/asm.h
===================================================================
--- boot/arch/ppc32/loader/asm.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/ppc32/loader/asm.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -33,5 +33,5 @@
 #define PAGE_SIZE   (1 << PAGE_WIDTH)
 
-#define TRANS_SIZE   1024
+#define TRANS_SIZE   2048
 #define BOOT_OFFSET  0x8000
 
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ boot/arch/sparc64/Makefile.inc	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -54,5 +54,5 @@
 	mkisofs -f -G $(TMP)/boot/isofs.b -B ... -r -o $@ $(TMP)/
 
-arch/$(BARCH)/loader/image.boot:
+arch/$(BARCH)/loader/image.boot: $(COMPONENTS) $(INIT_TASKS) $(RD_SRVS) $(RD_APPS) $(CFG)
 	$(MAKE) -C arch/$(BARCH)/loader PRECHECK=$(PRECHECK)
 
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/Makefile	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -229,5 +229,6 @@
 	generic/src/ipc/event.c \
 	generic/src/security/cap.c \
-	generic/src/sysinfo/sysinfo.c
+	generic/src/sysinfo/sysinfo.c \
+	generic/src/sysinfo/stats.c
 
 ## Kernel console support
@@ -278,6 +279,5 @@
 		test/print/print3.c \
 		test/print/print4.c \
-		test/thread/thread1.c \
-		test/sysinfo/sysinfo1.c
+		test/thread/thread1.c
 	
 	ifeq ($(KARCH),mips32)
@@ -344,6 +344,4 @@
 endif
 
-
-
 $(BIN): $(RAW)
 	$(OBJCOPY) -O $(BFD) $< $@
@@ -353,5 +351,5 @@
 
 $(RAW): $(LINK) $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(SYMTAB_OBJECTS)
-	$(LD) $(LFLAGS) -T $(LINK) -M -Map $(MAP) -o $@  $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SYMTAB_OBJECTS)
+	$(LD) -N $(LFLAGS) -T $(LINK) -M -Map $(MAP) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SYMTAB_OBJECTS)
 
 $(LINK): $(LINK).in $(DEPEND)
@@ -396,5 +394,5 @@
 $(REAL_MAP).bin: $(LINK) $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS)
 	echo $(SYMTAB_SECTION) | $(AS) $(AFLAGS) -o $(EMPTY_MAP)
-	$(LD) $(LFLAGS) -T $(LINK) -M -Map $(MAP_PREV) -o $@  $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(EMPTY_MAP)
+	$(LD) -N $(LFLAGS) -T $(LINK) -M -Map $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(EMPTY_MAP)
 	$(OBJDUMP) -t $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) > $(DUMP)
 	$(GENMAP) $(MAP_PREV) $(DUMP) $@
@@ -404,5 +402,5 @@
 	
 	echo $(SYMTAB_SECTION)" .incbin \"$@\"" | $(AS) $(AFLAGS) -o $(SIZEOK_MAP)
-	$(LD) $(LFLAGS) -T $(LINK) -M -Map $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SIZEOK_MAP)
+	$(LD) -N $(LFLAGS) -T $(LINK) -M -Map $(MAP_PREV) -o $@ $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) $(EXTRA_OBJECTS) $(SIZEOK_MAP)
 	$(OBJDUMP) -t $(ARCH_OBJECTS) $(GENARCH_OBJECTS) $(GENERIC_OBJECTS) > $(DUMP)
 	$(GENMAP) $(MAP_PREV) $(DUMP) $@
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/arch/arm32/_link.ld.in	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -7,5 +7,5 @@
  */
 
-#define KERNEL_LOAD_ADDRESS 0x80200000
+#define KERNEL_LOAD_ADDRESS 0x80800000
 
 OUTPUT_ARCH(arm)
Index: kernel/arch/mips32/include/arch.h
===================================================================
--- kernel/arch/mips32/include/arch.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/arch/mips32/include/arch.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -36,10 +36,9 @@
 #define KERN_mips32_ARCH_H_
 
-#define TASKMAP_MAX_RECORDS  32
-#define CPUMAP_MAX_RECORDS   32
+#include <typedefs.h>
 
-#define BOOTINFO_TASK_NAME_BUFLEN 32
-
-#include <typedefs.h>
+#define TASKMAP_MAX_RECORDS        32
+#define CPUMAP_MAX_RECORDS         32
+#define BOOTINFO_TASK_NAME_BUFLEN  32
 
 extern size_t cpu_count;
@@ -47,5 +46,5 @@
 typedef struct {
 	uintptr_t addr;
-	uint32_t size;
+	size_t size;
 	char name[BOOTINFO_TASK_NAME_BUFLEN];
 } utask_t;
@@ -53,5 +52,5 @@
 typedef struct {
 	uint32_t cpumap;
-	uint32_t cnt;
+	size_t cnt;
 	utask_t tasks[TASKMAP_MAX_RECORDS];
 } bootinfo_t;
Index: kernel/arch/mips32/include/asm/regname.h
===================================================================
--- kernel/arch/mips32/include/asm/regname.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/arch/mips32/include/asm/regname.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips32	
+/** @addtogroup mips32
  * @{
  */
@@ -69,28 +69,28 @@
 #define ra      31
 
-#define rindex		0
-#define rrandom		1
-#define entrylo0	2
-#define entrylo1	3
-#define context		4
-#define pagemask	5
-#define wired		6
-#define badvaddr	8
-#define count		9
-#define entryhi		10
-#define compare		11
-#define status		12
-#define cause		13
-#define epc		14
-#define rconfig		16
-#define lladdr		17
-#define watchlo		18
-#define watchhi		19
-#define xcontext	20
-#define rdebug		23
-#define depc		24
-#define eepc		30
+#define rindex    0
+#define rrandom   1
+#define entrylo0  2
+#define entrylo1  3
+#define context   4
+#define pagemask  5
+#define wired     6
+#define badvaddr  8
+#define count     9
+#define entryhi   10
+#define compare   11
+#define status    12
+#define cause     13
+#define epc       14
+#define rconfig   16
+#define lladdr    17
+#define watchlo   18
+#define watchhi   19
+#define xcontext  20
+#define rdebug    23
+#define depc      24
+#define eepc      30
 
-#endif /* KERN_mips32_REGNAME_H_ */
+#endif
 
 /** @}
Index: kernel/generic/include/cpu.h
===================================================================
--- kernel/generic/include/cpu.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/cpu.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -68,4 +68,8 @@
 					     are disabled. */
 
+	bool idle;
+	uint64_t idle_ticks;
+	uint64_t busy_ticks;
+
 	/**
 	 * Processor ID assigned by kernel.
@@ -73,5 +77,5 @@
 	unsigned int id;
 	
-	int active;
+	bool active;
 	int tlb_active;
 
Index: kernel/generic/include/func.h
===================================================================
--- kernel/generic/include/func.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/func.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -43,5 +43,4 @@
 extern void halt(void) __attribute__((noreturn));
 extern unative_t atoi(const char *text);
-extern void order(const uint64_t val, uint64_t *rv, char *suffix);
 
 #endif
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/ipc/sysipc.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -57,5 +57,5 @@
 unative_t sys_ipc_forward_slow(unative_t callid, unative_t phoneid,
     ipc_data_t *data, int mode);
-unative_t sys_ipc_hangup(int phoneid);
+unative_t sys_ipc_hangup(unative_t phoneid);
 unative_t sys_ipc_register_irq(inr_t inr, devno_t devno, unative_t method,
     irq_code_t *ucode);
Index: kernel/generic/include/mm/frame.h
===================================================================
--- kernel/generic/include/mm/frame.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/mm/frame.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -169,10 +169,11 @@
 extern bool zone_merge(size_t, size_t);
 extern void zone_merge_all(void);
-extern uint64_t zone_total_size(void);
+extern uint64_t zones_total_size(void);
+extern void zones_stats(uint64_t *, uint64_t *, uint64_t *, uint64_t *);
 
 /*
  * Console functions
  */
-extern void zone_print_list(void);
+extern void zones_print_list(void);
 extern void zone_print_one(size_t);
 
Index: kernel/generic/include/printf/printf_core.h
===================================================================
--- kernel/generic/include/printf/printf_core.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/printf/printf_core.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -51,5 +51,5 @@
 } printf_spec_t;
 
-int printf_core(const char *fmt, printf_spec_t *ps, va_list ap);
+extern int printf_core(const char *fmt, printf_spec_t *ps, va_list ap);
 
 #endif
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/proc/task.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -56,6 +56,5 @@
 #include <ipc/kbox.h>
 #include <mm/as.h>
-
-#define TASK_NAME_BUFLEN	20
+#include <sysinfo/abi.h>
 
 struct thread;
@@ -81,5 +80,5 @@
 	task_id_t taskid;
 	/** Task security context. */
-	context_id_t context;	
+	context_id_t context;
 
 	/** Number of references (i.e. threads). */
@@ -89,9 +88,10 @@
 
 	/** Task capabilities. */
-	cap_t capabilities;	
+	cap_t capabilities;
 
 	/* IPC stuff */
 	answerbox_t answerbox;  /**< Communication endpoint */
 	phone_t phones[IPC_MAX_PHONES];
+	stats_ipc_t ipc_info;   /**< IPC statistics */
 	/**
 	 * Active asynchronous messages. It is used for limiting uspace to
@@ -119,8 +119,9 @@
 	mutex_t futexes_lock;
 	/** B+tree of futexes referenced by this task. */
-	btree_t futexes;	
+	btree_t futexes;
 	
 	/** Accumulated accounting. */
-	uint64_t cycles;
+	uint64_t ucycles;
+	uint64_t kcycles;
 } task_t;
 
@@ -134,5 +135,5 @@
 extern task_t *task_find_by_id(task_id_t id);
 extern int task_kill(task_id_t id);
-extern uint64_t task_get_accounting(task_t *t);
+extern void task_get_accounting(task_t *t, uint64_t *ucycles, uint64_t *kcycles);
 extern void task_print_list(void);
 
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/proc/thread.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -48,4 +48,5 @@
 #include <proc/uarg.h>
 #include <udebug/udebug.h>
+#include <sysinfo/abi.h>
 
 #define THREAD_STACK_SIZE	STACK_SIZE
@@ -69,22 +70,4 @@
 #define THREAD_FLAG_NOATTACH	(1 << 3)
 
-/** Thread states. */
-typedef enum {
-	/** It is an error, if thread is found in this state. */
-	Invalid,
-	/** State of a thread that is currently executing on some CPU. */
-	Running,
-	/** Thread in this state is waiting for an event. */
-	Sleeping,
-	/** State of threads in a run queue. */
-	Ready,
-	/** Threads are in this state before they are first readied. */
-	Entering,
-	/** After a thread calls thread_exit(), it is put into Exiting state. */
-	Exiting,
-	/** Threads that were not detached but exited are Lingering. */
-	Lingering
-} state_t;
-
 /** Thread structure. There is one per thread. */
 typedef struct thread {
@@ -189,5 +172,6 @@
 	
 	/** Thread accounting. */
-	uint64_t cycles;
+	uint64_t ucycles;
+	uint64_t kcycles;
 	/** Last sampled cycle. */
 	uint64_t last_cycle;
@@ -252,5 +236,6 @@
 extern void thread_print_list(void);
 extern void thread_destroy(thread_t *);
-extern void thread_update_accounting(void);
+extern thread_t *thread_find_by_id(thread_id_t);
+extern void thread_update_accounting(bool);
 extern bool thread_exists(thread_t *);
 
Index: kernel/generic/include/str.h
===================================================================
--- kernel/generic/include/str.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/str.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -89,4 +89,7 @@
 extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
 
+extern char *str_dup(const char *src);
+extern char *str_ndup(const char *src, size_t n);
+
 extern char *str_chr(const char *str, wchar_t ch);
 
@@ -94,4 +97,8 @@
 extern bool wstr_remove(wchar_t *str, size_t pos);
 
+extern int str_uint64(const char *, char **, unsigned int, bool, uint64_t *);
+
+extern void order_suffix(const uint64_t val, uint64_t *rv, char *suffix);
+
 #endif
 
Index: kernel/generic/include/syscall/syscall.h
===================================================================
--- kernel/generic/include/syscall/syscall.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/syscall/syscall.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -71,5 +71,5 @@
 	SYS_IPC_REGISTER_IRQ,
 	SYS_IPC_UNREGISTER_IRQ,
-
+	
 	SYS_EVENT_SUBSCRIBE,
 	
@@ -82,9 +82,12 @@
 	SYS_PREEMPT_CONTROL,
 	
-	SYS_SYSINFO_VALID,
-	SYS_SYSINFO_VALUE,
+	SYS_SYSINFO_GET_TAG,
+	SYS_SYSINFO_GET_VALUE,
+	SYS_SYSINFO_GET_DATA_SIZE,
+	SYS_SYSINFO_GET_DATA,
 	
 	SYS_DEBUG_ENABLE_CONSOLE,
 	SYS_DEBUG_DISABLE_CONSOLE,
+	
 	SYS_IPC_CONNECT_KBOX,
 	SYSCALL_END
Index: kernel/generic/include/sysinfo/abi.h
===================================================================
--- kernel/generic/include/sysinfo/abi.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ kernel/generic/include/sysinfo/abi.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,131 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ * Data structures passed between kernel sysinfo and user space.
+ */
+
+#ifndef KERN_ABI_H_
+#define KERN_ABI_H_
+
+/** Number of load components */
+#define LOAD_STEPS        3
+
+/** Maximum task name size */
+#define TASK_NAME_BUFLEN  20
+
+/** Thread states */
+typedef enum {
+	/** It is an error, if thread is found in this state. */
+	Invalid,
+	/** State of a thread that is currently executing on some CPU. */
+	Running,
+	/** Thread in this state is waiting for an event. */
+	Sleeping,
+	/** State of threads in a run queue. */
+	Ready,
+	/** Threads are in this state before they are first readied. */
+	Entering,
+	/** After a thread calls thread_exit(), it is put into Exiting state. */
+	Exiting,
+	/** Threads that were not detached but exited are Lingering. */
+	Lingering
+} state_t;
+
+/** Statistics about a single CPU
+ *
+ */
+typedef struct {
+	unsigned int id;         /**< CPU ID as stored by kernel */
+	bool active;             /**< CPU is activate */
+	uint16_t frequency_mhz;  /**< Frequency in MHz */
+	uint64_t idle_ticks;     /**< Number of idle kernel quanta */
+	uint64_t busy_ticks;     /**< Number of busy kernel quanta */
+} stats_cpu_t;
+
+/** Physical memory statistics
+ *
+ */
+typedef struct {
+	uint64_t total;    /**< Total physical memory (bytes) */
+	uint64_t unavail;  /**< Unavailable (reserved, firmware) bytes */
+	uint64_t used;     /**< Allocated physical memory (bytes) */
+	uint64_t free;     /**< Free physical memory (bytes) */
+} stats_physmem_t;
+
+/** IPC statistics
+ *
+ * Associated with a task.
+ *
+ */
+typedef struct {
+	uint64_t call_sent;           /**< IPC calls sent */
+	uint64_t call_recieved;       /**< IPC calls received */
+	uint64_t answer_sent;         /**< IPC answers sent */
+	uint64_t answer_recieved;     /**< IPC answers received */
+	uint64_t irq_notif_recieved;  /**< IPC IRQ notifications */
+	uint64_t forwarded;           /**< IPC messages forwarded */
+} stats_ipc_t;
+
+/** Statistics about a single task
+ *
+ */
+typedef struct {
+	task_id_t task_id;            /**< Task ID */
+	char name[TASK_NAME_BUFLEN];  /**< Task name (in kernel) */
+	size_t virtmem;               /**< Size of VAS (bytes) */
+	size_t threads;               /**< Number of threads */
+	uint64_t ucycles;             /**< Number of CPU cycles in user space */
+	uint64_t kcycles;             /**< Number of CPU cycles in kernel */
+	stats_ipc_t ipc_info;         /**< IPC statistics */
+} stats_task_t;
+
+/** Statistics about a single thread
+ *
+ */
+typedef struct {
+	thread_id_t thread_id;  /**< Thread ID */
+	task_id_t task_id;      /**< Associated task ID */
+	state_t state;          /**< Thread state */
+	int priority;           /**< Thread priority */
+	uint64_t ucycles;       /**< Number of CPU cycles in user space */
+	uint64_t kcycles;       /**< Number of CPU cycles in kernel */
+	bool on_cpu;            /**< Associated with a CPU */
+	unsigned int cpu;       /**< Associated CPU ID (if on_cpu is true) */
+} stats_thread_t;
+
+/** Load fixed-point value */
+typedef uint32_t load_t;
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/sysinfo/stats.h
===================================================================
--- kernel/generic/include/sysinfo/stats.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ kernel/generic/include/sysinfo/stats.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_STATS_H_
+#define KERN_STATS_H_
+
+extern void kload(void *arg);
+extern void stats_init(void);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/sysinfo/sysinfo.h
===================================================================
--- kernel/generic/include/sysinfo/sysinfo.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ kernel/generic/include/sysinfo/sysinfo.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -39,53 +39,114 @@
 #include <str.h>
 
+/** Framebuffer info exported flags */
 extern bool fb_exported;
 
-typedef union sysinfo_item_val {
-	unative_t val;
-	void *fn; 
+/** Item value type
+ *
+ */
+typedef enum {
+	SYSINFO_VAL_UNDEFINED = 0,     /**< Undefined value */
+	SYSINFO_VAL_VAL = 1,           /**< Constant numeric value */
+	SYSINFO_VAL_DATA = 2,          /**< Constant binary data */
+	SYSINFO_VAL_FUNCTION_VAL = 3,  /**< Generated numeric value */
+	SYSINFO_VAL_FUNCTION_DATA = 4  /**< Generated binary data */
+} sysinfo_item_val_type_t;
+
+/** Subtree type
+ *
+ */
+typedef enum {
+	SYSINFO_SUBTREE_NONE = 0,     /**< No subtree (leaf item) */
+	SYSINFO_SUBTREE_TABLE = 1,    /**< Fixed subtree */
+	SYSINFO_SUBTREE_FUNCTION = 2  /**< Generated subtree */
+} sysinfo_subtree_type_t;
+
+struct sysinfo_item;
+
+/** Gerated numeric value function */
+typedef unative_t (*sysinfo_fn_val_t)(struct sysinfo_item *);
+
+/** Generated binary data function */
+typedef void *(*sysinfo_fn_data_t)(struct sysinfo_item *, size_t *, bool);
+
+/** Sysinfo item binary data
+ *
+ */
+typedef struct {
+	void *data;   /**< Data */
+	size_t size;  /**< Size (bytes) */
+} sysinfo_data_t;
+
+/** Sysinfo item value (union)
+ *
+ */
+typedef union {
+	unative_t val;              /**< Constant numberic value */
+	sysinfo_fn_val_t fn_val;    /**< Generated numeric value function */
+	sysinfo_fn_data_t fn_data;  /**< Generated binary data function */
+	sysinfo_data_t data;        /**< Constant binary data */
 } sysinfo_item_val_t;
 
+/** Sysinfo return holder
+ *
+ * This structure is generated from the constant
+ * items or by the generating functions. Note that
+ * the validity of the data is limited by the scope
+ * of single sysinfo invocation guarded by sysinfo_lock.
+ *
+ */
+typedef struct {
+	sysinfo_item_val_type_t tag;  /**< Return value type */
+	union {
+		unative_t val;            /**< Numberic value */
+		sysinfo_data_t data;      /**< Binary data */
+	};
+} sysinfo_return_t;
+
+/** Generated subtree function */
+typedef sysinfo_return_t (*sysinfo_fn_subtree_t)(const char *, bool);
+
+/** Sysinfo subtree (union)
+ *
+ */
+typedef union {
+	struct sysinfo_item *table;     /**< Fixed subtree (list of subitems) */
+	sysinfo_fn_subtree_t get_data;  /**< Generated subtree function */
+} sysinfo_subtree_t;
+
+/** Sysinfo item
+ *
+ */
 typedef struct sysinfo_item {
-	char *name;
-	union {
-		unative_t val;
-		void *fn; 
-	} val;
-
-	union {
-		struct sysinfo_item *table;
-		void *fn;
-	} subinfo;
-
-	struct sysinfo_item *next;
-	int val_type;
-	int subinfo_type;
+	char *name;                           /**< Item name */
+	
+	sysinfo_item_val_type_t val_type;     /**< Item value type */
+	sysinfo_item_val_t val;               /**< Item value */
+	
+	sysinfo_subtree_type_t subtree_type;  /**< Subtree type */
+	sysinfo_subtree_t subtree;            /**< Subtree */
+	
+	struct sysinfo_item *next;            /**< Sibling item */
 } sysinfo_item_t;
 
-#define SYSINFO_VAL_VAL        0
-#define SYSINFO_VAL_FUNCTION   1
-#define SYSINFO_VAL_UNDEFINED  U_SPECIAL
+extern void sysinfo_set_item_val(const char *, sysinfo_item_t **, unative_t);
+extern void sysinfo_set_item_data(const char *, sysinfo_item_t **, void *,
+    size_t);
+extern void sysinfo_set_item_fn_val(const char *, sysinfo_item_t **,
+    sysinfo_fn_val_t);
+extern void sysinfo_set_item_fn_data(const char *, sysinfo_item_t **,
+    sysinfo_fn_data_t);
+extern void sysinfo_set_item_undefined(const char *, sysinfo_item_t **);
 
-#define SYSINFO_SUBINFO_NONE      0
-#define SYSINFO_SUBINFO_TABLE     1
-#define SYSINFO_SUBINFO_FUNCTION  2
+extern void sysinfo_set_subtree_fn(const char *, sysinfo_item_t **,
+    sysinfo_fn_subtree_t);
 
-typedef unative_t (*sysinfo_val_fn_t)(sysinfo_item_t *root);
-typedef unative_t (*sysinfo_subinfo_fn_t)(const char *subname);
+extern void sysinfo_init(void);
+extern void sysinfo_dump(sysinfo_item_t *);
 
-typedef struct sysinfo_rettype {
-	unative_t val;
-	unative_t valid;
-} sysinfo_rettype_t;
-
-void sysinfo_set_item_val(const char *name, sysinfo_item_t **root, unative_t val);
-void sysinfo_dump(sysinfo_item_t **root, int depth);
-void sysinfo_set_item_function(const char *name, sysinfo_item_t **root, sysinfo_val_fn_t fn);
-void sysinfo_set_item_undefined(const char *name, sysinfo_item_t **root);
-
-sysinfo_rettype_t sysinfo_get_val(const char *name, sysinfo_item_t **root);
-
-unative_t sys_sysinfo_valid(unative_t ptr, unative_t len);
-unative_t sys_sysinfo_value(unative_t ptr, unative_t len);
+extern unative_t sys_sysinfo_get_tag(void *, size_t);
+extern unative_t sys_sysinfo_get_value(void *, size_t, void *);
+extern unative_t sys_sysinfo_get_data_size(void *, size_t, void *);
+extern unative_t sys_sysinfo_get_data(void *, size_t, void *, size_t);
 
 #endif
